
import P, R, S, C from require "lpeg"

cont = R("\128\191")
multibyte_character =  R("\194\223") * cont +
  R("\224\239") * cont * cont +
  R("\240\244") * cont * cont * cont

-- This is generated by web_sanitize and copied here for convenience, includes
-- all codepoints classified as whitespace compiled into optimal pattern
whitespace = S("\13\32\10\11\12\9") +
  P("\239\187\191") +
  P("\194") * S("\133\160") +
  P("\225") * (P("\154\128") + P("\160\142")) +
  P("\226") * (P("\128") * S("\131\135\139\128\132\136\140\175\129\133\168\141\130\134\169\138\137") + P("\129") * S("\159\160")) +
  P("\227\128\128")

-- direction marks by themselves are unprintable, we must see if something follows
direction_mark = P("\226\128") * S("\142\143\170\171\172\173\174") + P("\216\156")

unused_direction_mark = direction_mark * #((whitespace + direction_mark)^-1 * -1)
whitespace += unused_direction_mark

printable_character = S("\r\n\t") + R("\032\126") + multibyte_character

trim = whitespace^0 * C (whitespace^0 * (1-whitespace)^1)^0

string_length = (str) ->
  len = 0
  pos = 1
  while true
    res = printable_character\match str, pos
    break unless res
    pos = res
    len += 1

  unless pos > #str
    return nil, "invalid string"

  len

{:multibyte_character, :printable_character, :whitespace, :direction_mark, :trim, :string_length}
